<%@ Language=VBScript %>
<% Option Explicit
Response.Buffer = True
%>
<!-- Begin HTML header -->
<html>
<head>
<title>Photos demo</title>
</head>
<body>
<!-- End HTML Header -->
<%
'#################################################################################
'#
'# USAGE:
'# 
'# FREE OF CHARGE!
'#
'# OK, Written because I couldn't find any thing similar in any of the usual
'# libraries. It is designed so that the relatively untutored can maintain
'# their on-line photo album with nothing more than a basic image editing package, 
'# e.g. PaintShop Pro (www.jasc.com) or Microsoft Photo Editor (Part of Office),
'# and an FTP client such as CuteFTP or FTPExplorer. You should be able to avoid
'# ever having to edit the code.
'# All I ask is that:
'# 1. The following lines remain:
%>
<!-- Self administering on-line photo album written in ASP/VBScript by -->
<!-- Stuart Irving - stu.i@btinternet.com -->
<%
'# 2. I would also appreciate a brief email, if you take it live, letting me know 
'# the URL.
'#################################################################################
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'
' INSTALLATION:
' 
' 1. Create a folder anywhere on the site (eg www.site.com/photos/)
' 2. Insert the necessary HTML headers and footers and adjust the internal layout
'    as needed.
' 3. Put this file in the folder created in step 1.
' 4. For each set of pictures to publish create a subfolder
'    (e.g. www.site.com/photos/sept/ and www.site.com/photos/oct/)
' 5. If captions are used, rename the image files so that the filename is
'    the caption (problem: only certain punctuation marks can be used,
'	 apostrophes will break it every time).
' 6. Load the image files into their respective photos/folders
' 7. Open photos2.asp in a browser
' 8. Remove individual photos by deleting them
' 9. Whole albums can be switched off by prefixing the folder name with an
'    undescore("_")
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Declaration of variables and constants
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim i				' Counter
Dim tot				' Number of piccies
Dim pic				' Current picture
Dim dir				' Current folder
Dim showIdx			' User index preference: show/hide
Dim MyDirectory		' Path to folder containing photos2.asp
Dim MyFolders		' List of subfolders (albums)
Dim MyFiles			' List of files in an album
Dim folderFound		' individual subfolder
Dim fileFound		' individual photo
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Turn off captions globally by changing the value of captions to False
' Turn off captions individually by naming the file with an initial undescore (_)
' Turn off the index by changing the value of index to False
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Const captions	= True  ' Show captions globally y/n
Const index		= True	' Show the index of pictures y/n
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Store QueryStrings as variables (out of habit)
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Get querystring for pic number as sub-type integer
pic = Cint(Request.QueryString("pic"))
' Get name of folder containing current album
dir = Request.QueryString("dir")
' Get user index preference
If Request.QueryString("idx") = "" Then
	showIdx = True
Else
	showIdx = False
End If
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Create FileSystemObjects
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Set MyDirectory=Server.CreateObject("Scripting.FileSystemObject")
' MyFolders is contents of folder containing photos2.asp
Set MyFolders=MyDirectory.GetFolder(Server.MapPath("./"))
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' If there is no current album set it to the first one found
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
For Each folderFound In MyFolders.subfolders
	If dir = "" Then
		dir = folderFound.Name
	End If
Next
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Get contents of current album
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Set MyFiles=MyDirectory.GetFolder(Server.MapPath(dir))
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Count the photos
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
tot = -1
For Each filefound in MyFiles.files
	tot = tot + 1
Next
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Decide if target photo is outside the range and reset variable pic accordingly
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
If pic > tot Then
	pic = 0
ElseIf pic < 0 Then
	pic = tot
End If
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' If there is no current photo set current photo to the first one found
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
If Request.QueryString("pic") = "" Then
	pic = 0
End If
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Output some basic page layout - change this to suit the desired appearance
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write("<table border=0 cellpadding=5>" & vbCrLf)
Response.Write("<tr><td bgcolor=lightgrey align=center valign=middle height=500>" & vbCrLf)
Response.Write("<p><b>Album: " & dir & "</b></p><br>")
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Flick through current album until we get to the target photo (pic)
' Output the image path and filename with Server.URLPathEncode so that people who
' insist on clinging to that pathetic software they call Netscape, can see it.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
i = 0
For Each filefound In MyFiles.files
	If pic = i Then
		' Write out the image tag
		Response.Write ("<img alt='" & filefound.Name & "' src='" & Server.URLPathEncode(dir) & "/" & Server.URLPathEncode(fileFound.Name) & "'><br>" & vbCrLf)
		' Use File title as caption
		Response.Write("<p>&nbsp;")
		' Decide if captions are required (globally or individually)
		If captions And Left(filefound.Name,1) <> "_" Then
			' Write out filename as caption, but lop off the letters after the period
			Response.Write(Left(filefound.Name,(Len(filefound.name)-3)))
		End If
		Response.Write("&nbsp;</p>" & vbCrLf)
	End If
	i = i + 1
Next
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' More layout
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write("</td><td>")
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' The following decides if the index has been turned off by the webmaster or by
' the user, then writes out a list of captions
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
If showIdx And index Then
	Response.Write("<a href=photos2.asp?idx=no&dir=" & Server.URLEncode(dir) & "&pic=" & pic & ">< hide index ></a><br><hr>")
	Response.Write("<b>In this album:</b><br><br>")
	i = 0
	For Each filefound In MyFiles.files
		' Write out the link tag
		Response.Write ("<font size=2><a href='photos2.asp")
		Response.Write ("?dir=" & Server.URLEncode(dir) & "&pic=" & i & "'>")
		Response.Write (Left(filefound.Name,(Len(filefound.name)-3)) & "</a><br>" & vbCrLf)
		i = i + 1
	Next
	Response.Write("<hr>")
ElseIf index And Not showIdx Then
	Response.Write("<a href=photos2.asp?dir=" & Server.URLEncode(dir) & "&pic=" & pic & ">< show index ></a><br>")
End If
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Close any table cells
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write("&nbsp;</td></tr>" & vbCrLf)
Response.Write("<tr><td align=center valign=middle>")
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Write out previous and next photo links as text links but images could easily be
' used. Be careful with form buttons...! (Netscape again)
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write("<a href='photos2.asp?")
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Only include the QueryString index switch if indexes are allowed by the 
' webmaster and wanted by the user
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
If Not index Or Not showIdx Then
	Response.Write("idx=no&")
End If
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Finish the "next photo" link and start the "previous photo" link
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write("dir=" & Server.URLEncode(dir) & "&pic=" & pic-1 & "'><= prev</a>&nbsp;&nbsp;<a href='photos2.asp?")
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Only include the QueryString index switch if indexes are allowed by the 
' webmaster and wanted by the user
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
If Not index Or Not showIdx Then
	Response.Write("idx=no&")
End If
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Finish writing out the "next" link
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write("dir=" & Server.URLEncode(dir) & "&pic=" & pic+1 & "'>next =></a><br>" & vbCrLf & vbCrLf)
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' More layout
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write("</td><td>&nbsp;</td></tr>" & vbCrLf & "<tr><td align=center>")
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Write out menu of available albums as links to the photos in that folder
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write(" Choose Album: ")
For Each folderFound In MyFolders.SubFolders
	' Ignore any FrontPage Server Extension folders
	If Left(folderFound.Name,1) <> "_" Then
		Response.Write("<a href=photos2.asp?dir=" & Server.URLEncode(folderFound.Name))
		'
		'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		' Decide whether to include the index switch
		'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		If Not index Or Not showIdx Then
			Response.Write("&idx=no")
		End If
		Response.Write(">" & folderFound.Name &"</a>&nbsp;&nbsp;&nbsp;")
	End If
Next
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Finish the layout
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Response.Write(vbCrLf & "</td><td>&nbsp;</td></tr>" & vbCrLf & "</table>")
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Get rid of the objects
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Set MyDirectory		= Nothing
Set MyFiles			= Nothing
Set MyFolders		= Nothing
%>
<!-- Begin HTML footer -->
</body>
</html>
<!-- End HTML Footer -->